#include "gtk/gtk.bi"
#define null 0

'const true = 1
'const false = not true
dim shared as integer fullscreen = 0

'====================================================================================
'funes callback
sub launch cdecl (byval widget as GtkWidget ptr, byval _data as gpointer)
	var entry = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(_data)->entry))
	
	dim as string args = *entry + " " + str(fullscreen)
	run "bin/road3d", args
end sub

sub toggleFullscreen cdecl (byval widget as GtkWidget ptr)
	fullscreen = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget))
end sub

'====================================================================================
'incio
gtk_init(0, null)

'lista de resolues
dim as GList ptr res = null

res = g_list_append(res, strptr("1024x600"))
res = g_list_append(res, strptr("1280x720"))
res = g_list_append(res, strptr("1366x768"))
res = g_list_append(res, strptr("1440x900"))
res = g_list_append(res, strptr("1920x1080"))
res = g_list_append(res, strptr("640x480"))
res = g_list_append(res, strptr("800x600"))
res = g_list_append(res, strptr("1024x768"))

'cria janela gtk
var win = gtk_window_new(GTK_WINDOW_TOPLEVEL)
gtk_window_set_title(GTK_WINDOW(win), "Launcher")
gtk_window_set_position(GTK_WINDOW(win), GTK_WIN_POS_CENTER)

'evento do boto de fechar
g_signal_connect(G_OBJECT(win), "delete-event", G_CALLBACK(@gtk_main_quit), null)

'cria container principal
var main = gtk_vbox_new(false, 0)
gtk_container_set_border_width(GTK_CONTAINER(main), 10)
gtk_container_add(GTK_CONTAINER(win), main)

'cria frame opes
var frame = gtk_frame_new("Video options")
gtk_box_pack_start(GTK_BOX(main), frame, true, true, 0)

'cria container vdeo
var box = gtk_hbox_new(true, 0)
gtk_container_set_border_width(GTK_CONTAINER(box), 8)
gtk_container_add(GTK_CONTAINER(frame), box)

'cria combo box resolues
var combo = gtk_combo_new()
gtk_combo_set_popdown_strings(GTK_COMBO(combo), res)
gtk_box_pack_start(GTK_BOX(box), combo, true, true, 0)

'cria checkbox fullscreen
var check = gtk_check_button_new_with_label("Fullscreen")
'gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), true)
g_signal_connect(G_OBJECT(check), "clicked", G_CALLBACK(@toggleFullscreen), null)
gtk_box_pack_start(GTK_BOX(box), check, true, true, 0)

'cria boto launcher
var button = gtk_button_new_with_label("Play")
'var button = gtk_button_new_from_stock(GTK_STOCK_APPLY)
g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(@launch), combo)
gtk_box_pack_start(GTK_BOX(main), button, false, false, 8)

'cria rodap
var footer = gtk_statusbar_new()
gtk_statusbar_push(GTK_STATUSBAR(footer), null, strptr("Road3D launcher v1.0 (c) 2015 Thiago Marques"))
gtk_box_pack_start(GTK_BOX(main), footer, false, false, 0)

'desenha widget
gtk_widget_show_all(win)

gtk_main()

end 0


